package cn.com.infosec.jce.provider;

import cn.com.infosec.asn1.DEROctetString;
import java.io.IOException;
import java.security.AlgorithmParametersSpi;
import java.security.spec.AlgorithmParameterSpec;
import java.security.spec.InvalidParameterSpecException;

public abstract class JDKECDSAAlgParameters extends AlgorithmParametersSpi {
   public static class SigAlgParameters extends JDKAlgorithmParameters {
      protected byte[] engineGetEncoded() {
         return this.engineGetEncoded("ASN.1");
      }

      protected byte[] engineGetEncoded(String format) {
         if (format == null) {
            return this.engineGetEncoded("ASN.1");
         } else {
            return format.equals("ASN.1") ? (new DEROctetString(this.engineGetEncoded("RAW"))).getEncoded() : null;
         }
      }

      protected AlgorithmParameterSpec localEngineGetParameterSpec(Class paramSpec) {
         throw new InvalidParameterSpecException("unknown parameter spec passed to ECDSA parameters object.");
      }

      protected void engineInit(AlgorithmParameterSpec paramSpec) {
         throw new InvalidParameterSpecException("unknown parameter spec passed to ECDSA parameters object.");
      }

      protected void engineInit(byte[] params) {
      }

      protected void engineInit(byte[] params, String format) {
         throw new IOException("Unknown parameters format in IV parameters object");
      }

      protected String engineToString() {
         return "ECDSA Parameters";
      }
   }
}
